chiark / gitweb /
construct import commits differently (merge separate from contents)
[dgit.git] / dgit
1 #!/usr/bin/perl -w
2 # dgit
3 # Integration between git and Debian-style archives
4 #
5 # Copyright (C)2013 Ian Jackson
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 use strict;
21
22 use IO::Handle;
23 use Data::Dumper;
24 use LWP::UserAgent;
25 use Dpkg::Control::Hash;
26 use File::Path;
27 use POSIX;
28
29 our $suite = 'sid';
30 our $package;
31
32 our $sign = 1;
33 our $dryrun = 0;
34 our $changesfile;
35 our $new_package = 0;
36 our $existing_package = 'dpkg';
37
38 our %format_ok = map { $_=>1 } ("1.0","3.0 (native)","3.0 (quilt)");
39
40 our (@git) = qw(git);
41 our (@dget) = qw(dget);
42 our (@dput) = qw(dput);
43 our (@debsign) = qw(debsign);
44 our $keyid;
45
46 our $debug = 0;
47 open DEBUG, ">/dev/null" or die $!;
48
49 our %opts_opt_map = ('dget' => \@dget,
50                      'dput' => \@dput,
51                      'debsign' => \@debsign);
52
53 our $remotename = 'dgit';
54 our $ourdscfield = 'Vcs-Dgit-Master';
55 our $branchprefix = 'dgit';
56
57 sub lbranch () { return "$branchprefix/$suite"; }
58 my $lbranch_re = '^refs/heads/'.$branchprefix.'/([^/.]+)$';
59 sub lref () { return "refs/heads/".lbranch(); }
60 sub lrref () { return "refs/remotes/$remotename/$suite"; }
61 sub rrref () { return "refs/$branchprefix/$suite"; }
62 sub debiantag ($) { return "debian/$_[0]"; }
63
64 sub fetchspec () {
65     local $suite = '*';
66     return  "+".rrref().":".lrref();
67 }
68
69 our $ua;
70
71 sub url_get {
72     if (!$ua) {
73         $ua = LWP::UserAgent->new();
74         $ua->env_proxy;
75     }
76     print "downloading @_...\n";
77     my $r = $ua->get(@_) or die $!;
78     die "$_[0]: ".$r->status_line."; failed.\n" unless $r->is_success;
79     return $r->decoded_content();
80 }
81
82 our ($dscdata,$dscurl,$dsc);
83
84 sub printcmd {
85     my $fh = shift @_;
86     my $intro = shift @_;
87     print $fh $intro or die $!;
88     local $_;
89     foreach my $a (@_) {
90         $_ = $a;
91         if (s{['\\]}{\\$&}g || m{\s} || m{[^-_./0-9a-z]}i) {
92             print $fh " '$_'" or die $!;
93         } else {
94             print $fh " $_" or die $!;
95         }
96     }
97     print $fh "\n" or die $!;
98 }
99
100 sub runcmd {
101     printcmd(\*DEBUG,"+",@_) if $debug>0;
102     $!=0; $?=0;
103     die "@_ $! $?" if system @_;
104 }
105
106 sub cmdoutput_errok {
107     die Dumper(\@_)." ?" if grep { !defined } @_;
108     printcmd(\*DEBUG,"|",@_) if $debug>0;
109     open P, "-|", @_ or die $!;
110     my $d;
111     $!=0; $?=0;
112     { local $/ = undef; $d = <P>; }
113     die if P->error;
114     if (!close P) { print DEBUG "=>!$?\n" if $debug>0; return undef; }
115     chomp $d;
116     $d =~ m/^.*/;
117     print DEBUG "=> \`$&'",(length $' ? '...' : ''),"\n" if $debug>0; #';
118     return $d;
119 }
120
121 sub cmdoutput {
122     my $d = cmdoutput_errok @_;
123     defined $d or die "@_ $? $!";
124     return $d;
125 }
126
127 sub dryrun_report {
128     printcmd(\*STDOUT,"#",@_);
129 }
130
131 sub runcmd_ordryrun {
132     if (!$dryrun) {
133         runcmd @_;
134     } else {
135         dryrun_report @_;
136     }
137 }
138
139 our %defcfg = ('dgit.default.distro' => 'debian',
140                'dgit.default.username' => '',
141                'dgit.default.archive-query-default-component' => 'main',
142                'dgit.default.ssh' => 'ssh',
143                'dgit-distro.debian.git-host' => 'git.debian.org',
144                'dgit-distro.debian.git-proto' => 'git+ssh://',
145                'dgit-distro.debian.git-path' => '/git/dgit-repos',
146                'dgit-distro.debian.git-check' => 'ssh-cmd',
147                'dgit-distro.debian.git-create' => 'ssh-cmd',
148                'dgit-distro.debian.mirror' => 'http://ftp.debian.org/debian/');
149
150 sub cfg {
151     foreach my $c (@_) {
152         my $v;
153         {
154             local ($debug) = $debug-1;
155             $v = cmdoutput_errok(@git, qw(config --), $c);
156         };
157         if ($?==0) {
158             return $v;
159         } elsif ($?!=256) {
160             die "$c $?";
161         }
162         my $dv = $defcfg{$c};
163         return $dv if defined $dv;
164     }
165     return undef;
166 }
167
168 sub access_distro () {
169     return cfg("dgit-suite.$suite.distro",
170                "dgit.default.distro");
171 }
172
173 sub access_cfg ($) {
174     my ($key) = @_;
175     my $distro = access_distro();
176     my $value = cfg("dgit-distro.$distro.$key",
177                     "dgit.default.$key");
178     return $value;
179 }
180
181 sub access_gituserhost () {
182     my $user = access_cfg('git-user');
183     my $host = access_cfg('git-host');
184     return defined($user) && length($user) ? "$user\@$host" : $host;
185 }
186
187 sub access_giturl () {
188     my $url = access_cfg('git-url');
189     if (!defined $url) {
190         $url =
191             access_cfg('git-proto').
192             access_gituserhost().
193             access_cfg('git-path');
194     }
195     return "$url/$package.git";
196 }              
197
198 sub parsecontrol {
199     my $c = Dpkg::Control::Hash->new();
200     $c->load(@_) or return undef;
201     return $c;
202 }
203
204 sub parsechangelog {
205     my $c = Dpkg::Control::Hash->new();
206     my $p = new IO::Handle;
207     open $p, '-|', qw(dpkg-parsechangelog) or die $!;
208     $c->parse($p);
209     $?=0; $!=0; close $p or die "$! $?";
210     return $c;
211 }
212
213 our %rmad;
214
215 sub archive_query () {
216     my $query = access_cfg('archive-query');
217     $query ||= "madison:".access_distro();
218     $query =~ s/^(\w+):// or die "$query ?";
219     my $proto = $1;
220     my $url = $'; #';
221     die unless $proto eq 'madison';
222     $rmad{$package} ||= cmdoutput
223         qw(rmadison -asource),"-s$suite","-u$url",$package;
224     my $rmad = $rmad{$package};
225     if (!length $rmad) {
226         return ();
227     }
228     $rmad =~ m{^ \s*( [^ \t|]+ )\s* \|
229                  \s*( [^ \t|]+ )\s* \|
230                  \s*( [^ \t|/]+ )(?:/([^ \t|/]+))? \s* \|
231                  \s*( [^ \t|]+ )\s* }x or die "$rmad $?";
232     $1 eq $package or die "$rmad $package ?";
233     my $vsn = $2;
234     if ($suite ne $3) {
235         # madison canonicalises for us
236         print "canonical suite name for $suite is $3\n";
237         $suite = $3;
238     }
239     my $component;
240     if (defined $4) {
241         $component = $4;
242     } else {
243         $component = access_cfg('archive-query-default-component');
244     }
245     $5 eq 'source' or die "$rmad ?";
246     my $prefix = substr($package, 0, $package =~ m/^l/ ? 4 : 1);
247     my $subpath = "/pool/$component/$prefix/$package/${package}_$vsn.dsc";
248     return ($vsn,$subpath);
249 }
250
251 sub canonicalise_suite () {
252     archive_query() or die;
253 }
254
255 sub get_archive_dsc () {
256     my ($vsn,$subpath) = archive_query();
257     if (!defined $vsn) { $dsc=undef; return undef; }
258     $dscurl = access_cfg('mirror').$subpath;
259     $dscdata = url_get($dscurl);
260     my $dscfh = new IO::File \$dscdata, '<' or die $!;
261     print DEBUG Dumper($dscdata) if $debug>1;
262     $dsc = Dpkg::Control::Hash->new(allow_pgp=>1);
263     $dsc->parse($dscfh, 'dsc') or die "parsing of $dscurl failed\n";
264     print DEBUG Dumper($dsc) if $debug>1;
265     my $fmt = $dsc->{Format};
266     die "unsupported format $fmt, sorry\n" unless $format_ok{$fmt};
267 }
268
269 sub check_for_git () {
270     # returns 0 or 1
271     my $how = access_cfg('git-check');
272     if ($how eq 'ssh-cmd') {
273         my $r= cmdoutput
274             (access_cfg('ssh'),access_gituserhost(),
275              " set -e; cd ".access_cfg('git-path').";".
276              " if test -d $package.git; then echo 1; else echo 0; fi");
277         print DEBUG "got \`$r'\n";
278         die "$r $! $?" unless $r =~ m/^[01]$/;
279         return $r+0;
280     } else {
281         die "unknown git-check $how ?";
282     }
283 }
284
285 sub create_remote_git_repo () {
286     my $how = access_cfg('git-create');
287     if ($how eq 'ssh-cmd') {
288         runcmd_ordryrun
289             (access_cfg('ssh'),access_gituserhost(),
290              "set -e; cd ".access_cfg('git-path').";".
291              " mkdir -p $package.git;".
292              " cd $package.git;".
293              " if ! test -d objects; then git init --bare; fi");
294     } else {
295         die "unknown git-create $how ?";
296     }
297 }
298
299 our ($dsc_hash,$upload_hash);
300
301 our $ud = '.git/dgit/unpack';
302
303 sub prep_ud () {
304     rmtree($ud);
305     mkpath '.git/dgit';
306     mkdir $ud or die $!;
307 }
308
309 sub mktree_in_ud_from_only_subdir () {
310     # changes into the subdir
311     my (@dirs) = <*/.>;
312     die unless @dirs==1;
313     $dirs[0] =~ m#^([^/]+)/\.$# or die;
314     my $dir = $1;
315     chdir $dir or die "$dir $!";
316     die if stat '.git';
317     die $! unless $!==&ENOENT;
318     runcmd qw(git init -q);
319     rmtree('.git/objects');
320     symlink '../../../../objects','.git/objects' or die $!;
321     runcmd @git, qw(add -Af);
322     my $tree = cmdoutput @git, qw(write-tree);
323     $tree =~ m/^\w+$/ or die "$tree ?";
324     return ($tree,$dir);
325 }
326
327 sub dsc_files () {
328     map {
329         m/^\w+ \d+ (\S+)$/ or die "$_ ?";
330         $1;
331     } grep m/\S/, split /\n/, ($dsc->{'Checksums-Sha256'} || $dsc->{Files});
332 }
333
334 sub is_orig_file ($) {
335     local ($_) = @_;
336     m/\.orig(?:-\w+)?\.tar\.\w+$/;
337 }
338
339 sub make_commit ($) {
340     my ($file) = @_;
341     return cmdoutput @git, qw(hash-object -w -t commit), $file;
342 }
343
344 sub generate_commit_from_dsc () {
345     prep_ud();
346     chdir $ud or die $!;
347     my @files;
348     foreach my $f (dsc_files()) {
349         die if $f =~ m#/|^\.|\.dsc$|\.tmp$#;
350         push @files, $f;
351         link "../../../$f", $f
352             or $!==&ENOENT
353             or die "$f $!";
354     }
355     runcmd @dget, qw(--), $dscurl;
356     foreach my $f (grep { is_orig_file($_) } @files) {
357         link $f, "../../../../$f"
358             or $!==&EEXIST
359             or die "$f $!";
360     }
361     my ($tree,$dir) = mktree_in_ud_from_only_subdir();
362     runcmd qw(sh -ec), 'dpkg-parsechangelog >../changelog.tmp';
363     my $clogp = parsecontrol('../changelog.tmp','changelog') or die;
364     my $date = cmdoutput qw(date), '+%s %z', qw(-d),$clogp->{Date};
365     my $author = $clogp->{Maintainer};
366     $author =~ s#,.*##ms;
367     my $authline = "$author $date";
368     $authline =~ m/^[^<>]+ \<\S+\> \d+ [-+]\d+$/ or die $authline;
369     open C, ">../commit.tmp" or die $!;
370     print C <<END or die $!;
371 tree $tree
372 author $authline
373 committer $authline
374
375 $clogp->{Changes}
376
377 # imported from the archive
378 END
379     close C or die $!;
380     my $commithash = make_commit qw(../commit.tmp);
381     if ($upload_hash) {
382         open C, ">../commit2.tmp" or die $!;
383         print C <<END or die $!;
384 tree $tree
385 parent $upload_hash
386 parent $commithash
387 author $authline
388 committer $authline
389
390 Record $package ($clogp->{Version}) in archive suite $suite
391 END
392         $commithash = make_commit qw(../commit2.tmp);
393     }
394     print "synthesised git commit from .dsc $clogp->{Version}\n";
395     chdir '../../../..' or die $!;
396     cmdoutput @git, qw(update-ref -m),"dgit fetch import $clogp->{Version}",
397               'DGIT_ARCHIVE', $commithash;
398     cmdoutput @git, qw(log -n2), $commithash;
399     # ... gives git a chance to complain if our commit is malformed
400     my $outputhash = $commithash;
401     if ($upload_hash) {
402         chdir "$ud/$dir" or die $!;
403         runcmd @git, qw(reset --hard), $upload_hash;
404         runcmd qw(sh -ec), 'dpkg-parsechangelog >>../changelogold.tmp';
405         my $oldclogp = Dpkg::Control::Hash->new();
406         $oldclogp->parse('../changelogold.tmp','previous changelog') or die;
407         my $vcmp =
408             version_compare_string($oldclogp->{Version}, $clogp->{Version});
409         if ($vcmp < 0) {
410             # git upload/ is earlier vsn than archive, use archive
411         } elsif ($vcmp >= 0) {
412             print STDERR <<END or die $!;
413 Version actually in archive:    $clogp->{Version} (older)
414 Last allegedly pushed/uploaded: $oldclogp->{Version} (newer or same)
415 Perhaps the upload is stuck in incoming.  Using the version from git.
416 END
417         } else {
418             die "version in archive is same as version in git".
419                 " to-be-uploaded (upload/) branch but archive".
420                 " version hash no commit hash?!\n";
421         }
422         chdir '../../../..' or die $!;
423     }
424     rmtree($ud);
425     return $outputhash;
426 }
427
428 sub ensure_we_have_orig () {
429     foreach my $f (dsc_files()) {
430         next unless is_orig_file($f);
431         if (stat "../$f") {
432             die "$f ?" unless -f _;
433         } else {
434             die "$f $!" unless $!==&ENOENT;
435         }
436         my $origurl = $dscurl;
437         $origurl =~ s{/[^/]+$}{};
438         $origurl .= "/$f";
439         die "$f ?" unless $f =~ m/^${package}_/;
440         die "$f ?" if $f =~ m#/#;
441         runcmd_ordryrun qw(sh -ec),'cd ..; exec "$@"','x',
442             @dget,'--',$origurl;
443     }
444 }
445
446 sub rev_parse ($) {
447     return cmdoutput @git, qw(rev-parse), "$_[0]~0";
448 }
449
450 sub is_fast_fwd ($$) {
451     my ($ancestor,$child) = @_;
452     my $mb = cmdoutput @git, qw(merge-base), $ancestor, $child;
453     return rev_parse($mb) eq rev_parse($ancestor);
454 }
455
456 sub git_fetch_us () {
457     die "cannot dry run with fetch" if $dryrun;
458     runcmd @git, qw(fetch),access_giturl(),fetchspec();
459 }
460
461 sub fetch_from_archive () {
462     # ensures that lrref() is what is actually in the archive,
463     #  one way or another
464     get_archive_dsc() or return 0;
465     $dsc_hash = $dsc->{$ourdscfield};
466     if (defined $dsc_hash) {
467         $dsc_hash =~ m/\w+/ or die "$dsc_hash $?";
468         $dsc_hash = $&;
469         print "last upload to archive specified git hash\n";
470     } else {
471         print "last upload to archive has NO git hash\n";
472     }
473
474     my $lrref_fn = ".git/".lrref();
475     if (open H, $lrref_fn) {
476         $upload_hash = <H>;
477         chomp $upload_hash;
478         die "$lrref_fn $upload_hash ?" unless $upload_hash =~ m/^\w+$/;
479     } elsif ($! == &ENOENT) {
480         $upload_hash = '';
481     } else {
482         die "$lrref_fn $!";
483     }
484     print DEBUG "last upload hash $upload_hash\n";
485     my $hash;
486     if (defined $dsc_hash) {
487         die "missing git history even though dsc has hash"
488             unless $upload_hash;
489         $hash = $dsc_hash;
490         ensure_we_have_orig();
491     } else {
492         $hash = generate_commit_from_dsc();
493     }
494     if ($upload_hash) {
495         die "not fast forward on last upload branch!".
496             " (archive's version left in DGIT_ARCHIVE)"
497             unless is_fast_fwd($dsc_hash, $upload_hash);
498     }
499     if ($upload_hash ne $hash) {
500         my @upd_cmd = (@git, qw(update-ref -m), 'dgit fetch', lrref(), $hash);
501         if (!$dryrun) {
502             cmdoutput @upd_cmd;
503         } else {
504             dryrun_report @upd_cmd;
505         }
506     }
507     return 1;
508 }
509
510 sub clone ($) {
511     my ($dstdir) = @_;
512     die "dry run makes no sense with clone" if $dryrun;
513     mkdir $dstdir or die "$dstdir $!";
514     chdir "$dstdir" or die "$dstdir $!";
515     runcmd @git, qw(init -q);
516     runcmd @git, qw(config), "remote.$remotename.fetch", fetchspec();
517     open H, "> .git/HEAD" or die $!;
518     print H "ref: ".lref()."\n" or die $!;
519     close H or die $!;
520     runcmd @git, qw(remote add), 'origin', access_giturl();
521     if (check_for_git()) {
522         print "fetching existing git history\n";
523         git_fetch_us();
524         runcmd @git, qw(fetch origin);
525     } else {
526         print "starting new git history\n";
527     }
528     fetch_from_archive() or die;
529     runcmd @git, qw(reset --hard), lrref();
530     print "ready for work in $dstdir\n";
531 }
532
533 sub fetch () {
534     if (check_for_git()) {
535         git_fetch_us();
536     }
537     fetch_from_archive() or die;
538 }
539
540 sub pull () {
541     fetch();
542     runcmd_ordryrun @git, qw(merge -m),"Merge from $suite [dgit]",
543         lrref();
544 }
545
546 sub dopush () {
547     runcmd @git, qw(diff --quiet HEAD);
548     my $clogp = parsechangelog();
549     $package = $clogp->{Source};
550     my $dscfn = "${package}_$clogp->{Version}.dsc";
551     stat "../$dscfn" or die "$dscfn $!";
552     $dsc = parsecontrol("../$dscfn");
553     prep_ud();
554     chdir $ud or die $!;
555     print "checking that $dscfn corresponds to HEAD\n";
556     runcmd qw(dpkg-source -x --), "../../../../$dscfn";
557     my ($tree,$dir) = mktree_in_ud_from_only_subdir();
558     chdir '../../../..' or die $!;
559     runcmd @git, qw(diff --exit-code), $tree;
560 #fetch from alioth
561 #do fast forward check and maybe fake merge
562 #    if (!is_fast_fwd(mainbranch
563 #    runcmd @git, qw(fetch -p ), "$alioth_git/$package.git",
564 #        map { lref($_).":".rref($_) }
565 #        (uploadbranch());
566     $dsc->{$ourdscfield} = rev_parse('HEAD');
567     $dsc->save("../$dscfn.tmp") or die $!;
568     if (!$dryrun) {
569         rename "../$dscfn.tmp","../$dscfn" or die "$dscfn $!";
570     } else {
571         print "[new .dsc left in $dscfn.tmp]\n";
572     }
573     if (!$changesfile) {
574         my $pat = "../${package}_$clogp->{Version}_*.changes";
575         my @cs = glob $pat;
576         die "$pat ?" unless @cs==1;
577         ($changesfile) = @cs;
578     }
579     my $tag = debiantag($dsc->{Version});
580     if (!check_for_git()) {
581         create_remote_git_repo();
582     }
583     runcmd_ordryrun @git, qw(push),access_giturl(),"HEAD:".rrref();
584     if ($sign) {
585         my @tag_cmd = (@git, qw(tag -s -m),
586                        "Release $dsc->{Version} for $suite [dgit]");
587         push @tag_cmd, qw(-u),$keyid if defined $keyid;
588         push @tag_cmd, $tag;
589         runcmd_ordryrun @tag_cmd;
590         my @debsign_cmd = @debsign;
591         push @debsign_cmd, "-k$keyid" if defined $keyid;
592         push @debsign_cmd, $changesfile;
593         runcmd_ordryrun @debsign_cmd;
594     }
595     runcmd_ordryrun @git, qw(push),access_giturl(),"refs/tags/$tag";
596     my $host = access_cfg('upload-host');
597     my @hostarg = defined($host) ? ($host,) : ();
598     runcmd_ordryrun @dput, @hostarg, $changesfile;
599 }
600
601 sub cmd_clone {
602     parseopts();
603     my $dstdir;
604     die if defined $package;
605     if (@ARGV==1) {
606         ($package) = @ARGV;
607     } elsif (@ARGV==2 && $ARGV[1] =~ m#^\w#) {
608         ($package,$suite) = @ARGV;
609     } elsif (@ARGV==2 && $ARGV[1] =~ m#^[./]#) {
610         ($package,$dstdir) = @ARGV;
611     } elsif (@ARGV==3) {
612         ($package,$suite,$dstdir) = @ARGV;
613     } else {
614         die;
615     }
616     $dstdir ||= "$package";
617     clone($dstdir);
618 }
619
620 sub branchsuite () {
621     my $branch = cmdoutput_errok @git, qw(symbolic-ref HEAD);
622     if ($branch =~ m#$lbranch_re#o) {
623         return $1;
624     } else {
625         return undef;
626     }
627 }
628
629 sub fetchpullargs () {
630     if (!defined $package) {
631         my $sourcep = parsecontrol('debian/control');
632         $package = $sourcep->{Source};
633     }
634     if (@ARGV==0) {
635         $suite = branchsuite();
636         if (!$suite) {
637             my $clogp = parsechangelog();
638             $suite = $clogp->{Distribution};
639         }
640         canonicalise_suite();
641         print "fetching from suite $suite\n";
642     } elsif (@ARGV==1) {
643         ($suite) = @ARGV;
644         canonicalise_suite();
645     } else {
646         die;
647     }
648 }
649
650 sub cmd_fetch {
651     parseopts();
652     fetchpullargs();
653     fetch();
654 }
655
656 sub cmd_pull {
657     parseopts();
658     fetchpullargs();
659     pull();
660 }
661
662 sub cmd_push {
663     parseopts();
664     die if defined $package;
665     my $clogp = parsechangelog();
666     $package = $clogp->{Source};
667     if (@ARGV==0) {
668         $suite = $clogp->{Distribution};
669         if ($new_package) {
670             local ($package) = $existing_package; # this is a hack
671             canonicalise_suite();
672         }
673     } else {
674         die;
675     }
676     if (fetch_from_archive()) {
677         is_fast_fwd(lrref(), 'HEAD') or die;
678     } else {
679         die unless $new_package;
680     }
681     dopush();
682 }
683
684 sub cmd_build {
685     # we pass further options and args to git-buildpackage
686     die if defined $package;
687     my $clogp = parsechangelog();
688     $suite = $clogp->{Distribution};
689     $package = $clogp->{Source};
690     runcmd_ordryrun
691         qw(git-buildpackage -us -uc --git-no-sign-tags),
692         '--git-builder=dpkg-buildpackage -i\.git/ -I.git',
693         "--git-debian-branch=".lbranch(),
694         @ARGV;
695 }
696
697 sub parseopts () {
698     my $om;
699     while (@ARGV) {
700         last unless $ARGV[0] =~ m/^-/;
701         $_ = shift @ARGV;
702         last if m/^--?$/;
703         if (m/^--/) {
704             if (m/^--dry-run$/) {
705                 $dryrun=1;
706             } elsif (m/^--no-sign$/) {
707                 $sign=0;
708             } elsif (m/^--new$/) {
709                 $new_package=1;
710             } elsif (m/^--(\w+)=(.*)/s && ($om = $opts_opt_map{$1})) {
711                 $om->[0] = $2;
712             } elsif (m/^--(\w+):(.*)/s && ($om = $opts_opt_map{$1})) {
713                 push @$om, $2;
714             } elsif (m/^--existing-package=(.*)/s) {
715                 $existing_package = $1;
716             } else {
717                 die "$_ ?";
718             }
719         } else {
720             while (m/^-./s) {
721                 if (s/^-n/-/) {
722                     $dryrun=1;
723                 } elsif (s/^-D/-/) {
724                     open DEBUG, ">&STDERR" or die $!;
725                     $debug++;
726                 } elsif (s/^-N/-/) {
727                     $new_package=1;
728                 } elsif (s/^-c(.*=.*)//s) {
729                     push @git, '-c', $1;
730                 } elsif (s/^-C(.*)//s) {
731                     $changesfile = $1;
732                 } elsif (s/^-k(.*)//s) {
733                     $keyid=$1;
734                 } else {
735                     die "$_ ?";
736                 }
737             }
738         }
739     }
740 }
741
742 parseopts();
743 die unless @ARGV;
744 my $cmd = shift @ARGV;
745
746 { no strict qw(refs); &{"cmd_$cmd"}(); }